:orphan:

.. _api_client_gui_guide:

API Graphic user interface guide
================================

In order to help you using our API and our php client, we provide a graphic user interface module that you could use as a base for your tests and developments.
It is fully customizable, and we made it as easy as possible to modify so you can make it your very own.
The main features are implemented for you to see a glimpse of what is possible to do, and let you the possibility to develop features that fit the best with your needs.

Overview
--------

This interface is based on a MVC architecture. Each service would then be managed with its own model, controller and view.
The model retrieves the data from the Fnac platform, the controller would make actions on these data and load them into the view to make them readable.

The purpose of this interface is to explain how you can use our Php client. Some features are already implemented, but you are totally free to modify them and write your own, or adapt them to fit your system.

The features already implemented are:
 * Offers listing
 * Single offer update
 * Orders listing
 * Single orders update (Accepting, Shipping)
 * Current offers import batches listing
 * Incidents on orders listing
 * Shop's invoices downloading


Installation
------------

You can download our php client on this `link <../../download/fnacapiclient.tgz>`_. You only need to extract the archive at the root folder of your server. You would then edit the configuration file to make it work.

Configuration
-------------

Edit the config.yml file in the config/ folder and fill it in with the parameters that you have been given: partner_id, shop_id, key and service url.
Please ensure to not remove the spaces in the beginning of each line. The indentation is needed for parameters to be loaded correctely.

Homepage
--------

The homepage is actually a dashboard where you can put some information of your account to highlight. It also gives the Fnac API service availability.

.. image:: gui_homepage_nok_V2.png

.. image:: gui_homepage_ok_V2.png


Offers
------

The offers query page makes you able to browse your catalog and eventually modify the price or the quantity of an offer. You can also delete offers.
When an offer is updated or deleted, an offers_update query is sent to our service. It gives you back a batch_id which can be used to get information on the update processing.

Suggestions of features to add:
 * Single offer add form
 * Massive offers add/update form
 * Reset catalog (all quantities to 0)
 * Get the current best prices for a given offer (Pricing service must be enabled on your account to work, please contact us to check if it is the case)
 * ...

.. image:: gui_offers_query_V2.png

.. image:: gui_batch_status_ok.png

Orders
------

The orders query page displays all the orders placed on your shop, sorted by their status. You can accept or refuse newly created orders, and when accepted, you can mark them as shipped.
The current interface uses orders global actions, which means that the same action will be made on each order line of an order that contains several items.

Suggestions of features to add:
 * Multiple lines handling
 * Massive orders update
 * Orders sorting by date
 * ...

.. image:: gui_orders_query_V2.png

.. image:: gui_orders_query_detail_V2.png


Batch
-----

The batch query page displays currently running and queued offers update files.

.. image:: gui_batch_status_running.png


Invoices
--------

You can retrieve all your invoices from this page. Invoicing occurs every 5 days.

.. image:: gui_invoices.png


XML Resquest/Response display
-----------------------------

In order to understand how the API works, you can view an export of the XML request generated by our client, and get an export of the response that is sent back.
A link is displayed on the top right corner to display these exports.

.. image:: gui_showxml_V2.png

.. image:: gui_displayxml_V2.png


Templates
---------

All the templates are gathered in the templates/ folder. You can modify them as you want. The data to display in these templates are initialized within the View file of the used service.
When modifying these templates, just keep in mind that all data processing should be handled in the controller, modified by the model and loaded in the view.

You can also modify the stylesheet file which is located in the css folder. You may modify the extra.css file to add new classes or override the existing ones.

The interface uses some javascript interactions with the jQuery library, located in the js/ folder.